#include <iostream>
#include <fstream>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <ctime>
#include <cstdlib>
#include <wiringPi.h>
#include <wiringSerial.h>
#include <wiringPiI2C.h>
#include <sstream>
#define WAKE_SW 0
#define CMD_MLDP 2
#define WAKE_HW 3
#include "SN2CV8.h"
using namespace std;

													// g++ -std=c++0x -o SN2C_C -lwiringPi SN2CV5.cpp SN2C_CentraleV4.cpp

string temp;

int main()
{
	erreur: ;
	SN2C sn2c;
	int fd;
	int fd2;
	int fd3;
	int nombre[8];
	wiringPiSetup();
	pinMode(WAKE_SW, OUTPUT);
	pinMode(WAKE_HW, OUTPUT);
	pinMode(CMD_MLDP, OUTPUT);

	if((fd2 = wiringPiI2CSetup(0x68)) < 0)														//ouverture de l'I2C avec la RTC
	{
		cerr<<"Impossible de démarer l'I2C"<<endl;
		return 1;
		goto erreur;
	}

	if((fd3 = wiringPiI2CSetup(0x48)) < 0)														//ouverture de l'I2C avec le LM76
	{
		cerr<<"Impossible de démarer l'I2C"<<endl;
		return 1;
		goto erreur;
	}

	if (wiringPiSetup () == -1)																	//démarage de WiringPi (GPIO)
	{  
		cerr<<"Impossible de démarrer wirinPi. Erreur : "<<strerror (errno);
		return 1 ;
		goto erreur;
	}

	while(1)																					//mise en boucle du programme
	{	
		
		
		
		 if ((fd = serialOpen("/dev/ttyAMA0", 115200)) < 0)										//ouverture de l'UART (port ttyAMA0)
		{
			cerr<<"Impossible d'ouvrir le port /dev/ttyAMA0. Erreur : "<<strerror (errno);
 			return 1 ;
			goto erreur;
		}

		time_t t = time(NULL);
		temp = ctime(&t);																		//Récupération de la date sur raspberry

		digitalWrite(WAKE_SW,1);		
		digitalWrite(WAKE_HW, 1);
		digitalWrite(CMD_MLDP, 0);

		
		sn2c.ecriture_RTC(fd2, temp);	
		string date_RTC;
		date_RTC = sn2c.recup_date(fd2);														//récupération de la date sur la RTC
		cout<<date_RTC<<endl;  																	//affichage de la date de la RTC
			
		sn2c.initialisation_centrale(fd);														//initialisation du module BLE en tant que centrale
			
//		sn2c.synchronisation_C(fd, temp);														//synchronisation de la date avec le module périphérique
		

		string renvoieMACRSSI = sn2c.connexion_centrale(fd);											//connexion avec le module périphérique en vue d'une réception des données
		if (renvoieMACRSSI[12] == '1')
		{
			cerr<<"Problèmes de connexion"<<endl;
			goto erreur;
		}

		
		char adresse[13];
		char RSSI[4];
		for(int i=0; i<12;i++)
		{
			adresse[i] = renvoieMACRSSI[i];
		}
		adresse[12] = '\0';
		
		int rssi =0;
		stringstream conversion;
		RSSI[0] = renvoieMACRSSI[14];
		RSSI[1] = renvoieMACRSSI[15];
		RSSI[2] = '\0';
		conversion<<hex<<RSSI;
		conversion>>rssi;
		rssi = 0 - rssi;
		cout<<"L'adresse MAC du phériphérique est "<<adresse<<" et le niveaux du RSSI est de "<<rssi<<" dBm"<<endl;

		string data;
		data = sn2c.recevoir_data(fd);															//réception des données
		cout<<"La température reçu est de :"<<data<<endl;																		//affichage des données
		cout<<"La température reçu est de :"<<data<<endl;																		//affichage des données
		delay(30000);                                                                                          	
		serialClose(fd);																		//fermeture de l'UART
									
	}
}





