#include <string>
#include <cstring>
#include <stdlib.h>
#include <stdio.h>
#include<iostream>
#include <wiringPi.h>
#include <wiringSerial.h>
#include <wiringPiI2C.h>
#include <math.h>
#include "SN2CV8.h"
#define CMD_MLDP 2
#define WAKE_SW 0

using namespace std;

SN2C::SN2C()
{

}

int attente_string(int fd, string bla)
{
	int taille = bla.size();
	char bla2[taille+1];
	while(bla2 != bla)
	{	
		if(serialGetchar(fd) == -1) return 1;
		while(serialGetchar(fd) != bla[0]);
			bla2[0] = bla[0];
		for(int i(1); i<taille; i++) bla2[i] = serialGetchar(fd);
			bla2[taille] = '\0';	
			return 0;
	}	
}


void tobin(int data, int digit, int nombre[])
{
	int i;
	int temp;
	temp=data;
	for (i=0;i<digit;i++) 
	{
		nombre[i]= (temp & (1 << i) ? 1 : 0);
	}
}

void SN2C::ecriture_RTC(int fd2, string date)
{

		int sec =0;
		int min =0;
		int h =0;
		int n =0;
		int j =0;
		int m =0;
		int a =0;

		switch(date[0])
		{
			case'M':
			j = 1;					
			break;

			case'T':
			if(date[1] == 'u')
			{
				j = 2;
			}
			else
			{
				j = 4;
			}
			break;

			case'W':
			j =3;
			break;

			case'F':
			j =5;
			break;

			case'S':
			if(date[1] == 'a')
			{
				j =6;
			}			
			else
			{
				j =7;
			}
			break;
		}
		
		switch(date[4])
		{
			
			case'F':
			m =2;
			break;

			case'M':
			if(date[6] == 'r')
			{
				m =3;
			}
			else
			{
				m =5;
			}
			break;

			case'A':
			if(date[5] == 'p')
			{
				m =4;
			}
			else
			{
				m =8;
			}
			break;
			
			case'J':
			if(date[6] == 'n')
			{
				if(date[5] == 'a')
				{
					m = 1;
				}
				else
				{
				m =6;
				}
			}
			else
			{
				m =7;
			}
			break;
		
			case'S':
			m =9;
			break;

			case'O':
			m =10;
			break;

			case'N':
			m =11;
			break;

			case'D':
			m =12;
			break;
		}
		
		switch(date[8])
		{
			case'1':
			n = n+10;
			break;

			case'2':
			n = n+20;
			break;
	
			case'3':
			n = n+30;
			break;
		}

		switch(date[9])
		{
			case'1':
			n = n+1;
			break;

			case'2':
			n = n+2;
			break;

			case'3':
			n = n+3;
			break;

			case'4':
			n = n+4;
			break;

			case'5':
			n = n+5;
			break;

			case'6':
			n = n+6;
			break;

			case'7':
			n = n+7;
			break;

			case'8':
			n = n+8;
			break;

			case'9':
			n = n+9;
			break;
		}

		switch(date[11])
		{
			case'1':
			h = h+10;
			break;

			case'2':
			h = h+20;
			break;
		}

		switch(date[12])
		{
			case'1':
			h = h+1;
			break;

			case'2':
			h = h+2;
			break;

			case'3':
			h = h+3;
			break;

			case'4':
			h =h+4;
			break;

			case'5':
			h = h+5;
			break;

			case'6':
			h = h+6;
			break;

			case'7':
			h = h+7;
			break;

			case'8':
			h = h+8;
			break;

			case'9':
			h = h+9;
			break;
		}

		switch(date[14])
		{
			case'1':
			min = min+10;
			break;

			case'2':
			min = min+20;
			break;

			case'3':
			min = min+30;
			break;

			case'4':
			min = min+40;
			break;

			case'5':
			min = min+50;
			break;
		}

		switch(date[15])
		{
			case'1':
			min = min+1;
			break;

			case'2':
			min = min+2;
			break;

			case'3':
			min = min+3;
			break;

			case'4':
			min =min+4;
			break;

			case'5':
			min = min+5;
			break;

			case'6':
			min = min+6;
			break;

			case'7':
			min = min+7;
			break;

			case'8':
			min = min+8;
			break;

			case'9':
			min = min+9;
			break;
		}

		switch(date[17])
		{
			case'1':
			sec = sec+10;
			break;

			case'2':
			sec = sec+20;
			break;

			case'3':
			sec = sec+30;
			break;

			case'4':
			sec = sec+40;
			break;

			case'5':
			sec = sec+50;
			break;
		}

		switch(date[18])
		{
			case'1':
			sec = sec+1;
			break;

			case'2':
			sec = sec+2;
			break;

			case'3':
			sec = sec+3;
			break;

			case'4':
			sec =sec+4;
			break;

			case'5':
			sec = sec+5;
			break;

			case'6':
			sec = sec+6;
			break;

			case'7':
			sec = sec+7;
			break;

			case'8':
			sec = sec+8;
			break;

			case'9':
			sec = sec+9;
			break;
		}

		switch(date[22])
		{
			case'1':
			a = a+10;
			break;

			case'2':
			a = a+20;
			break;
			
			case'3':
			a = a+30;
			break;
		}

		switch(date[23])
		{
			case'1':
			a = a+1;
			break;

			case'2':
			a = a+2;
			break;

			case'3':
			a = a+3;
			break;

			case'4':
			a =a+4;
			break;

			case'5':
			a = a+5;
			break;

			case'6':
			a = a+6;
			break;

			case'7':
			a = a+7;
			break;

			case'8':
			a = a+8;
			break;

			case'9':
			a = a+9;
			break;
		}

		











		wiringPiI2CWriteReg8(0x48, 0x00, (((sec/10) << 4) | (sec%10)));
		wiringPiI2CWriteReg8(0x48, 0x01, (((min/10) << 4) | (min%10)));
		wiringPiI2CWriteReg8(0x48, 0x02, (((h/10) << 4) | (h%10)));
		wiringPiI2CWriteReg8(0x48, 0x03, j);
		wiringPiI2CWriteReg8(0x48, 0x04, (((n/10) << 4) | (n%10)));
		wiringPiI2CWriteReg8(0x48, 0x05, (((m/10) << 4) | (m%10)));
		wiringPiI2CWriteReg8(0x48, 0x06, (((a/10) << 4)  | (a%10)));
		
}

string SN2C::recup_date(int fd2)
{
	int sec = wiringPiI2CReadReg8(fd2, 0x00);
	int min = wiringPiI2CReadReg8(fd2, 0x01);
	int h = wiringPiI2CReadReg8(fd2, 0x02);
	int j = wiringPiI2CReadReg8(fd2, 0x03);
	int n = wiringPiI2CReadReg8(fd2, 0x04);
	int m = wiringPiI2CReadReg8(fd2, 0x05);
	int a = wiringPiI2CReadReg8(fd2, 0x06);
	string date;
	string jour_semaine;
	int nombre[8];

	//tobin(sec,8,nombre);
//	int secondes = (nombre[0] * 1) + (nombre[1] * 2) + (nombre[2] * 4) + (nombre[3] *8) + (((nombre[4] * 1) + (nombre[5] * 2) + (nombre[6] * 4)) * 10);
	int secondes = ((sec >> 4)*10) + (sec&0x0f) ;

	//tobin(min,8,nombre);
	//int minutes = (nombre[0] * 1) + (nombre[1] * 2) + (nombre[2] * 4) + (nombre[3] *8) + (((nombre[4] * 1) + (nombre[5] * 2) + (nombre[6] * 4)) * 10);
	int minutes = ((min >> 4)*10) + (min&0x0f);

	tobin(h,8,nombre);
	int heure = (h&0x0f) + ((nombre[4] *1)*10) + ((nombre[5] * 1)*20);

	//tobin(n,8,nombre);
	int jour = j;

	switch (jour)
	{
		case 1:
		jour_semaine = "Lundi";
		break;

		case 2:
		jour_semaine = "mardi";
		break;

		case 3:
		jour_semaine  = "Mercredi";
		break;

		case 4:
		jour_semaine = "Jeudi";
		break;

		case 5:
		jour_semaine = "Vendredi";
		break;

		case 6:
		jour_semaine = "Samedi";
		break;

		case 7:
		jour_semaine = "Dimanche";
	}

	
	//tobin(n,8,nombre);
	//int numero = (nombre[0] * 1) + (nombre[1] * 2) + (nombre[2] * 4) + (nombre[3] *8) + (((nombre[4] * 1) + (nombre[5] * 2)) * 10);
	int numero = ((n>>4)*10) + (n&0x0f); 

	//tobin(m,8,nombre);
	//int mois = (nombre[0] * 1) + (nombre[1] * 2) + (nombre[2] * 4) + (nombre[3] *8) + ((nombre[4] * 1) * 10);
	int mois = ((m>>4)*10) + (m&0x0f);

	//tobin(a,8,nombre);
	//int annee = (nombre[0] * 1) + (nombre[1] * 2) + (nombre[2] * 4) + (nombre[3] *8) + (((nombre[4] * 1) + (nombre[5] * 2) + (nombre[6] * 4) + (nombre[7] * 8)) * 10);
	int annee = ((a>>4)*10) + (a&0x0f);

	date = jour_semaine+" "+to_string(numero)+"/"+to_string(mois)+"/"+to_string(annee)+" "+to_string(heure)+":"+to_string(minutes)+":"+to_string(secondes);

	return date;
}


int SN2C::initialisation_p(int fd)
{
	serialPuts(fd, "sf,1\r");
	delay(100);
	serialPuts(fd, "ss,00000000\r");
	delay(100);
	serialPuts(fd, "sr,32000000\r");
	delay(100);
	cout<<"reboot"<<endl;
	serialPuts(fd, "r,1\r");
	delay(3000);
	cout<<"reboot effectuer"<<endl;
	return 1;
}


int SN2C::connexion_p(int fd)
{
	string reboot = "reboot";
	string connected = "Connected";
	serialFlush(fd);
	delay(500);
	cout<<"attente de la connexion au module centrale"<<endl;
	attente_string(fd, connected);
	cout<<"Connecté au module centrale"<<endl;
	return 1;
	
}


void SN2C::envoie_data(int fd, string data)
{	
	string deco ="deco";
	int taille = data.size();
	char bla[taille+1];
	for(int i=0; i< taille; i++)
	{
		bla[i] = data[i];
	}
	bla[taille+1] = '\0';
	digitalWrite(CMD_MLDP, 1);
	string MLDP = "MLDP";
	attente_string(fd, MLDP);
	cout<<"MLDP actif"<<endl;
	delay(1000);
	serialPuts(fd, bla);
	attente_string(fd, deco);
	delay(1000);
	digitalWrite(CMD_MLDP, 0);
	cout<<"MLDP désactivé"<<endl;
}


int SN2C::initialisation_centrale(int fd)
{	
	char data[10];
/*	serialPuts(fd,"+");
	delay(100);
	for(int i =0;i<9;i++)
	{
		data[i] = serialGetchar(fd);
	}
	if(data[5] == 'n')
	{
		serialPuts(fd, "+");
	}*/
	delay(100);
	serialPuts(fd,"sb,4");
	delay(100);
	serialPuts(fd, "sf,1\r");
	delay(100);
	serialPuts(fd, "ss,00000000\r");
	delay(100);
	serialPuts(fd, "sr,92000000\r");
	delay(100);
	cout<<"Reboot"<<endl;
	serialPuts(fd, "r,1\r");
	delay(3000);
	cout<<"Reboot effectué"<<endl;
	return 1;
}


string SN2C::connexion_centrale(int fd)
{
	char addresse[24];
	char test[17];
	char data[19];
	int erreur =0;
	data[0] = 'E';
	data[1] = ',';
	data[2] = '0';
	data[3] = ',';
	data[16] = '\r';
	serialFlush(fd);
	delay(100);
	serialPuts(fd, "f\r");
	delay(100);
	serialPuts(fd, "x\r");
	delay(100);
	cout<<"Connexion en cours"<<endl;

	for(int i=0; i<23;i++)
	{
		addresse[i] = serialGetchar(fd);
	}

	for(int i=0; i<12; i++)
	{
		test[i] = addresse[i+5];
		if(test[i] == 255)
		{
			test[12] = '1';
		}
	}


	for(int i=0;i<12;i++)
	{
		data[i+4] = test[i];
	}
	string connected = "Connected";
	data[17] = '\0';
	serialPuts(fd, data);
	 cout<<"Connecté"<<endl;
	
	
	test[12] = '0';
	test[13] = addresse[20];
	test[14] = addresse[21];
	test[15] = addresse[22];
	test[16] = '\0';

	return test;




}


string SN2C::recup_temp(int fd3)
{	
	int data = wiringPiI2CReadReg16(fd3, 0x00);
	int temp[16];
	int cal = 0;
	int lsb = 0;
	int msb = 0;
	tobin(data, 16, temp);
	
	lsb = ((temp[11] * 1) + (temp[12] * 2) + (temp[13] *4) + (temp[14] * 8) + (temp[15] * 16));
	msb = ((temp[0] * 32) + (temp[1] * 64) + (temp[2] * 128) + (temp[3] * 256) + (temp[4] * 512) + (temp[5] * 1024) + (temp[6] * 2048) + (temp[7] * 4096));

	cout<<lsb<<endl;
	cout<<msb<<endl;
	cal = lsb + msb;
	cout<<cal<<endl;
	float temps = cal * 0.0625;
	cout<<temps<<endl;

	return to_string(temps);
}


string SN2C::recevoir_data(int fd)
{		
	char data[100];
	string MLDP = "MLDP";
	attente_string(fd, MLDP);
	cout<<"MLDP"<<endl;
	for(int i =0; i<30;i++)
	{
		data[i] = serialGetchar(fd);
	}	
	data[30] = '\0';
	delay(2000);
	serialPuts(fd, "deco");
	return data;
}

void SN2C::deconnexion_p(int fd)
{	
	
	delay(1000);
	digitalWrite(WAKE_SW, 0);
	delay(1000);
	digitalWrite(WAKE_SW, 1);
	delay(1000);
	serialPuts(fd,"k\r\n");
	cout<<"Arret du module"<<endl;
	serialFlush(fd);
	cout<<"Terminer"<<endl;
}

void SN2C::synchronisation_C(int fd, string date)
{
	SN2C sn2c;
	cout<<"Synchronisation en cour"<<endl;
	sn2c.connexion_centrale(fd);
	string MLDP = "MLDP";
	char data[25];
	for(int i =0; i<24; i++)
	{
		data[i] = date[i];
	}
	data[24] = '\0';
	attente_string(fd, MLDP);
	serialPuts(fd, data);
	
	cout<<"Syncronisation terminée"<<endl;
	
}

string SN2C::synchronisation_P(int fd, int fd2)
{
	cout<<"Synchronisation en cour"<<endl;
	string connect = "Connected";
	string MLDP = "MLDP";
	string date;
	attente_string(fd, connect);
	digitalWrite(CMD_MLDP, 1);
	attente_string(fd, MLDP);
	for(int i =0; i<24; i++)
	{
		date[i] = serialGetchar(fd);
	}
	date[24] = '\0';
	digitalWrite(CMD_MLDP, 0);
	delay(1000);
	serialPuts(fd, "k\r\n");
	delay(500);
	serialFlush(fd);
	
	ecriture_RTC(fd2, date);
	
	return date;
}




















